<?php
require "config.inc.php";
require "ldap.inc.php";
require "actions.inc.php";
require_once ('ipxe_functions.inc.php');

header("Content-type: text/plain");
$ipxe = "#!ipxe\n";
$mac = $_POST['mac'] ?? "none";
$url = "http://{$_SERVER["SERVER_ADDR"]}:{$_SERVER["SERVER_PORT"]}/ipxe/";
$header = "menu Preboot eXecution Environment\n";
$menu_timeout = 30000;
$menu_default = $_POST['menu-default'] ?? "installation-windows";
$token = $_POST['token'] ?? "";
$platform = $_POST['platform'] ?? "legacy";

if (empty($token) || ($token == "default")) {
    if (! isset($_POST['username']) || ! isset($_POST['password'])) {
        $ipxe .= "params\n";
        $ipxe .= "param mac " . $mac . "\n";
        $ipxe .= "param platform " . $platform . "\n";
        $ipxe .= "chain --replace --autofree " . $url . "boot.php##params\n";
        ipxe_out($config, $ipxe);
        exit();
    } else {
        $username = $_POST['username'];
        $password = $_POST['password'];
        $token = login_action($config, $mac, q2a($username, $platform), q2a($password, $platform));

        if ($token == "") {
            $ipxe .= "echo Authentication failed! && sleep 5\n";
            $ipxe .= "params\n";
            $ipxe .= "param mac " . $mac . "\n";
            $ipxe .= "param platform " . $platform . "\n";
            $ipxe .= "chain --replace --autofree " . $url . "boot.php##params\n";
            ipxe_out($config, $ipxe);
            exit();
        }
    }
}
check_system_accounts($config);
$machine = search_machine($config, $mac);
if (count($machine) == 0)
    $menu_default = "set-name";
$name = $machine['cn'] ?? "";
$ip = $machine['iphostnumber'] ?? $_SERVER['REMOTE_ADDR'];
$state = $machine['state'] ?? "dhcp";
$ipxe .= "params\n";
$ipxe .= "param token " . $token . "\n";
$ipxe .= "param mac " . $mac . "\n";
$ipxe .= "param name " . $name . "\n";
$ipxe .= "param platform " . $platform . "\n";
// set resolution and background
$ipxe .= "console --x 1024 --y 768 --picture png/ipxe-se4.png\n";
$ipxe .= ":menu\n";
$ipxe .= "menu Preboot eXecution Environment pour mac : $mac ($token)\n";
$ipxe .= "set menu-default $menu_default\n";
$ipxe .= "set menu-timeout $menu_timeout\n";

$ipxe .= title("Menu");
$ipxe .= "item --key x exit   (x) Quitter le menu pour demarrer le poste normalement\n";

$ipxe .= title("Enregistrement du poste");
$ipxe .= "item --key n set-name  (n) Donner un nom au poste : $name\n";
if (count($machine) > 0) {
    if (@is_dual_boot($config, $machine)) {
        $ipxe .= "item --key n single (n) Passer en simple boot \n";
    } else {
        $ipxe .= "item --key d double (d) Passer en double boot \n";
    }
    $ipxe .= "item --key a salle (a) Ajouter a une salle\n";
    // $ipxe .= "item --key d dhcp (d) Reserver une IP : $ip : " . $state . "\n";
    $ipxe .= "item --key p parcs (p) Ajouter a un parc\n";
}
$ipxe .= title("Maintenance du poste");
$ipxe .= "item --key m maintenance  (m) Outils de maintenance (syrescuecd,clonezilla,etc...)\n";
if (count($machine) > 0) {
    $ipxe .= title("Clonage");
    $ipxe .= "item --key c clonage  (c) Clonage en direct des postes \n";
    $ipxe .= title("Installation");
    $ipxe .= "item --key i installation-windows  (i) Installation automatique de Windows\n";
    $ipxe .= "item --key l installation-linux  (l) Installation de Linux Debian et Ubuntu\n";
}
$ipxe .= title("Autres options");
$ipxe .= "item --key s shell  (s) iPXE shell\n";

$ipxe .= "choose --default \${menu-default} --timeout \${menu-timeout} selected && goto \${selected} || exit 0\n";

$ipxe .= ":shell\n";
$ipxe .= "echo iPXE shell...\n";
$ipxe .= "shell\n";

$ipxe .= ":exit\n";
$ipxe .= boot_disk();

$ipxe .= ":maintenance\n";
$ipxe .= "chain --replace --autofree  " . $url . "maintenance.php##params\n";

$ipxe .= ":set-name\n";
$ipxe .= "chain --replace --autofree  " . $url . "enregistrement.php##params\n";

$ipxe .= ":salle\n";
$ipxe .= "chain --replace --autofree  " . $url . "salles.php##params\n";

$ipxe .= ":parcs\n";
$ipxe .= "chain --replace --autofree  " . $url . "parcs.php##params\n";

$ipxe .= ":single\n";
$ipxe .= "param double 0\n";
$ipxe .= "chain --replace --autofree  " . $url . "double.php##params\n";

$ipxe .= ":double\n";
$ipxe .= "param double 1\n";
$ipxe .= "chain --replace --autofree  " . $url . "double.php##params\n";

$ipxe .= ":dhcp\n";
$ipxe .= "chain --replace --autofree  " . $url . "reservation.php##params\n";

$ipxe .= ":clonage\n";
$ipxe .= "chain --replace --autofree  " . $url . "clonage.php##params\n";

$ipxe .= ":installation-windows\n";
$ipxe .= "chain --replace --autofree " . $url . "installation-windows.php##params\n";

$ipxe .= ":installation-linux\n";
$ipxe .= "chain --replace --autofree " . $url . "installation-linux.php##params\n";

$ipxe .= ":back\n";
$ipxe .= "chain --replace --autofree " . $url . "boot.php##params\n";
ipxe_out($config, $ipxe);
?>
