<?php
/*
 * choix du nom de la machine, et enregistrement dans l'annuaire AD
 */
require "config.inc.php";
require "ldap.inc.php";
require "actions.inc.php";
require_once ('ipxe_functions.inc.php');

$ipxe = "#!ipxe\n";
$menu_timeout = '10000';
$ipxe .= "console --x 1024 --y 768 --picture png/ipxe-se4.png\n";
$token = $_POST['token'] ?? "";
$mac = $_POST['mac'] ?? "none";
$name = $_POST['name'] ?? "";
$platform = $_POST['platform'] ?? "legacy";
if (auth_action($config, $mac, $token)) {
    $machine = get_action($config, $mac, $token);
    if (isset($machine['cn'])) {
        $registered_name = $machine['cn'];
    } else {
        $registered_name = "";
    }
    if (! empty($_POST['new_name'])) {
        $new_name = add_hostname_suffix($config, q2a(substr($_POST['new_name'], 0, 15), $platform));
        if ($registered_name == $new_name) {
            $ipxe .= "params\n";
            $ipxe .= "param token " . $token . "\n";
            $ipxe .= "param mac " . $mac . "\n";
            $ipxe .= "param name " . $new_name . "\n";
            $ipxe .= "param platform " . $platform . "\n";
            $ipxe .= "param menu-default set-name\n";
            $ipxe .= "echo La machine est deja enregistree sous ce nom " . $new_name . "\n";
            $ipxe .= "sleep 3\n";
            $ipxe .= "chain --replace --autofree admin.php##params\n";
        } elseif ($registered_name != "") {
            delete_ad($config, $registered_name, "computer");
        }
        if (count($machine = search_machine($config, $new_name)) == 0) {
            // on crée une machine avec un enregistrement mac, mais on ne définit pas d'ip réservée à ce stade.
            $res = create_machine($config, $new_name, $config['computers_rdn'], "reservation iPXE");
            if ($res) {
                $machine = search_machine($config, $new_name);
            }
        } else {
            $res = true;
        }
        if ($res) {
            if (isset($machine['networkaddress'])) {
                if ($machine['networkaddress'] != $mac) {
                    $attrs = array(
                        'networkaddress' => $mac
                    );
                    $mode = "replace";
                    $res = modify_ad($config, $new_name, "machine", $attrs, $mode);
                }
            } else {
                $attrs = array(
                    'networkaddress' => $mac
                );
                $mode = "add";
                $res = modify_ad($config, $new_name, "machine", $attrs, $mode);
            }
        }
        if ($res) {
            delete_action($mac);
            set_action($config, $new_name, "ipxe", "", $token);
            $ipxe .= "params\n";
            $ipxe .= "param token " . $token . "\n";
            $ipxe .= "param mac " . $mac . "\n";
            $ipxe .= "param name " . $new_name . "\n";
            $ipxe .= "param menu-default dhcp\n";
            $ipxe .= "param platform " . $platform . "\n";
            $ipxe .= "echo OK ! nom " . $new_name . " reserve pour " . $mac . "\n";
            $ipxe .= "sleep 3\n";

            $ipxe .= "chain --replace --autofree admin.php##params\n";
        } else {
            $ipxe .= "params\n";
            $ipxe .= "param token " . $token . "\n";
            $ipxe .= "param mac " . $mac . "\n";
            $ipxe .= "param name " . $new_name . "\n";
            $ipxe .= "param menu-default set-name\n";
            $ipxe .= "param platform " . $platform . "\n";
            $ipxe .= "echo ERREUR ! nom " . $new_name . " invalide pour " . $mac . "\n";
            $ipxe .= "sleep 3\n";
            $ipxe .= "chain --replace --autofree admin.php##params\n";
        }
    } else {

        $ipxe .= "echo Enregistrement du nom pour nom : " . $name . ", mac : " . $mac . " \n";
        $ipxe .= "echo -n Entrez le nom de la machine : \n";
        $ipxe .= "set name " . $name . "\n";
        $ipxe .= "read name\n";
        $ipxe .= "params\n";
        $ipxe .= "param token " . $token . "\n";
        $ipxe .= "param mac " . $mac . "\n";
        $ipxe .= "param new_name \${name}\n";
        $ipxe .= "param platform " . $platform . "\n";
        $ipxe .= "chain --replace --autofree enregistrement.php##params\n";
    }
} else {
    $ipxe .= "params\n";
    $ipxe .= "param mac '" . $mac . "'\n";
    $ipxe .= "param token " . $token . "\n";
    $ipxe .= "param platform " . $platform . "\n";
    $ipxe .= "echo ERREUR ! acces refuse\n";
    $ipxe .= "sleep 3\n";
    $ipxe .= "chain --replace --autofree admin.php##params\n";
}
ipxe_out($config, $ipxe);
?>
 